//
// NETDEMO
// Copyright (c) 2003 Rama C. Hoetzlein
//

#ifndef NET_SOCK
	#define NET_SOCK

	class NetAddress {
	public:
		void SetPort (int p);
		void SetBroadcast (void);
		void SetAny (void);
		int GetPort (void)		{return port;}
		
		inline sockaddr*	GetAddress (void)			{return (sockaddr*) &addr;}
		inline int			GetAddressSize (void)		{return addr_size;}
		inline int*			GetAddressSizeMdfy (void)	{return &addr_size;}
		inline void			SetAddressSize (void)		{addr_size = sizeof(addr);}
	private:
		sockaddr_in		addr;
		int				addr_size;
		in_addr			in_addr;
		int				port;
	};

	class NetSock {
	public:
		void Create (char p);
		void SetMode (char m);
		
		void SetSrc (NetAddress& d)		{src = d;}
		void SetSrcPort (int p)			{src.SetPort (p);}
		void SetSrcAny (int p)			{src.SetPort (p); src.SetAny();}
		NetAddress& GetSrc (void)		{return src;}
		void GetSrcName (char* buf, unsigned long* buflen) {WSAAddressToString (src.GetAddress(), src.GetAddressSize(), NULL, buf, buflen);}
		
		void SetDest (NetAddress& d)	{dest = d;}
		void SetDestPort (int p)		{dest.SetPort (p);}
		void SetDestBroadcast (int p)	{dest.SetPort (p); dest.SetBroadcast();}
		NetAddress& GetDest (void)		{return dest;}
		void GetDestName (char* buf, unsigned long* buflen) {WSAAddressToString (dest.GetAddress(), dest.GetAddressSize(), NULL, buf, buflen);}
		
		void SetSendTime (int t)		{sendtime = t;}
		int GetSendTime	(void)			{return sendtime;}
		void SetTimeout (int sec, int msec) {timeout.tv_sec = sec; timeout.tv_usec = msec;}
		timeval* GetTimeoutMdfy (void)	{return &timeout;}		
		
		void SetConnected (bool c)		{connected = c;}
		bool GetConnected (void)		{return connected;}
		SOCKET GetSocket (void)			{return sock;}

		int SendDataTo (char *buf, int len);
		int RecvDataFrom (char *buf, int len);
		int SendData (char *buf, int len);
		int RecvData (char *buf, int len);
		int BindToSrc (void);
		int BindToDest (void);
		int ConnectToSrc (void);
		int ConnectToDest (void);
	private:
		SOCKET		sock;
		NetAddress	src;
		NetAddress	dest;
		int			sendtime;
		int			recvtime;
		timeval		timeout;
		bool		connected;
	};


#endif
